#include <Mouse.h>

#define JOYSTICK_X_PIN A0
#define JOYSTICK_Y_PIN A1
#define JOYSTICK_BUTTON_PIN 2

int buttons[5] = {7, 6, 5, 4, 3};
bool enable = false;
int wheelDirection = 0;

void setup(){
  Mouse.begin();
  for(int i = 0; i < 5; i++){
    pinMode(buttons[i], INPUT);
  }
  pinMode(JOYSTICK_BUTTON_PIN, INPUT_PULLUP);
}

void loop(){
  if(digitalRead(JOYSTICK_BUTTON_PIN) == LOW){
    enable = !enable;
    delay(500);
  }

  if(enable){
    if(digitalRead(buttons[0]) == HIGH){
      Mouse.click(MOUSE_LEFT);
      delay(200);
    }
    if(digitalRead(buttons[1]) == HIGH){
      Mouse.click(MOUSE_MIDDLE);
      delay(200);
    }
    if(digitalRead(buttons[2]) == HIGH){
      Mouse.click(MOUSE_RIGHT);
      delay(200);
    }
    if(digitalRead(buttons[3]) == HIGH){
      wheelDirection++;
      delay(200);
    }
    if(digitalRead(buttons[4]) == HIGH){
      wheelDirection--;
      delay(200);
    }
    
    int xDelta = axisDelta(JOYSTICK_X_PIN);
    int yDelta = axisDelta(JOYSTICK_Y_PIN);
    Mouse.move(xDelta, yDelta, wheelDirection);
    wheelDirection = 0;
  }
  
  delay(10);
}

int axisDelta(int axisPin){
  return (analogRead(axisPin)-512)/150;
}